# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_by_name import iJobByName
from bs_monitor.db.tables.job import tJob

class dJobByName:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobByName()
        self.orec     = tJob()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec_deft(self,
                  name: str) -> "dJobByName":
        """
        Execute the query by setting all the inputs.

        :param name: str
        :return: Self for convenience.
        """
        self.irec.name = name

        return self.exec()

    def exec(self, irec: iJobByName = None) -> "dJobByName":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobByName", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  j.*
from
  monitor.job j
where
  j.name = :name""")

        self._dbstmnt.bind_in("name", self.irec.name, str, 256)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("name", str, 256)
        self._dbstmnt.bind_out("group_id", str, 128)
        self._dbstmnt.bind_out("program_path", str, 256)
        self._dbstmnt.bind_out("program_args", str, 256)
        self._dbstmnt.bind_out("priority", int, 4)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.name = self._dbstmnt.result[1]
        self.orec.group_id = self._dbstmnt.result[2]
        self.orec.program_path = self._dbstmnt.result[3]
        self.orec.program_args = self._dbstmnt.result[4]
        self.orec.priority = self._dbstmnt.result[5]
        self.orec.stamp_by = self._dbstmnt.result[6]
        self.orec.stamp_tm = self._dbstmnt.result[7]

        return True

    def fetch_all(self, outList: tJob.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

