# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job_inst import tJobInst

class dJobInstReadyToRun:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.orec     = tJobInst()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec(self) -> "dJobInstReadyToRun":
        """
        Execute the query.

        :return: Self for convenience.
        """
        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstReadyToRun", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  m.*
from
  monitor.jobinst m,
  (
    select
      i.id,
      lpad(cast(i.priority as varchar), 3, '0') || '_' || to_char(i.process_date, 'YYYYMMDDHH24MISS') || '_' || lpad(cast(i.id as varchar), 64, '0') as key,
      i.group_job
    from
      monitor.jobinst i,
      (
        select
          group_job
        from
          monitor.jobinst
        where
          status = 'P'
        group by
          group_job
        except
        select
          group_job
        from
          monitor.jobinst
        where
          status in ('R', 'W')
        group by
          group_job
      ) g
    where
      i.group_job     = g.group_job        and
      i.status        = 'P'               and
      i.process_date <= current_timestamp and
      (
        (i.parent_id is null)
          or
        (i.parent_id in (select
                          xx.id
                        from
                          monitor.jobinst xx
                        where
                          xx.id = i.parent_id and
                          xx.status in ('C', 'O')))
      )
  ) x
where
  m.id = x.id
order by
  m.group_job,
  x.key
limit
  100""")

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("parent_id", int, 8)
        self._dbstmnt.bind_out("job_id", int, 8)
        self._dbstmnt.bind_out("batchinst_id", int, 8)
        self._dbstmnt.bind_out("process_date", datetime.datetime)
        self._dbstmnt.bind_out("priority", int, 4)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("extra_args", str, 256)
        self._dbstmnt.bind_out("group_job", str, 128)
        self._dbstmnt.bind_out("group_batch", str, 128)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.parent_id = self._dbstmnt.result[1]
        self.orec.job_id = self._dbstmnt.result[2]
        self.orec.batchinst_id = self._dbstmnt.result[3]
        self.orec.process_date = self._dbstmnt.result[4]
        self.orec.priority = self._dbstmnt.result[5]
        self.orec.status = self._dbstmnt.result[6]
        self.orec.extra_args = self._dbstmnt.result[7]
        self.orec.group_job = self._dbstmnt.result[8]
        self.orec.group_batch = self._dbstmnt.result[9]
        self.orec.stamp_by = self._dbstmnt.result[10]
        self.orec.stamp_tm = self._dbstmnt.result[11]

        return True

    def fetch_all(self, outList: tJobInst.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

