# This file was generated by mettlegen.db.GenPy3 [ver 2.0] on Tue Sep 22 18:56:58 2020
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_by_site import iBatchBySite
from bs_monitor.db.tables.batch import tBatch

class dBatchBySite:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchBySite()
        self.orec     = tBatch()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        sys_date: int) -> "dBatchBySite":
        """
        Execute the query by setting all the inputs.

        :param sys_date: int
        :return: Self for convenience.
        """
        self.irec.sys_date = sys_date

        return await self.exec()

    async def exec(self, irec: iBatchBySite = None) -> "dBatchBySite":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchBySite", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""SELECT
  b.*
FROM
  monitor.Batch b
    JOIN
  monitor.MonDate d
    ON d.id = 'rundate'
WHERE
  b.parent_id IS NULL AND
  b.status         = 'A'      AND
  b.runDate       <= :sysDate AND
  DATE(b.rundate) <= d.value""")

        self._dbstmnt.bind_in("sysDate", self.irec.sys_date, int, 4)

        self._dbstmnt.bind_out("id", int, 4)
        self._dbstmnt.bind_out("parent_id", int, 4)
        self._dbstmnt.bind_out("name", str, 256)
        self._dbstmnt.bind_out("group_id", str, 128)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("cycle", str, 1)
        self._dbstmnt.bind_out("rundate", datetime.datetime)
        self._dbstmnt.bind_out("run_interval", int, 4)
        self._dbstmnt.bind_out("run_time", str, 6)
        self._dbstmnt.bind_out("ext_data", dict)
        self._dbstmnt.bind_out("modified_by", str, 128)
        self._dbstmnt.bind_out("tm_stamp", datetime.datetime)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.parent_id = self._dbstmnt.result[1]
        self.orec.name = self._dbstmnt.result[2]
        self.orec.group_id = self._dbstmnt.result[3]
        self.orec.status = self._dbstmnt.result[4]
        self.orec.cycle = self._dbstmnt.result[5]
        self.orec.rundate = self._dbstmnt.result[6]
        self.orec.run_interval = self._dbstmnt.result[7]
        self.orec.run_time = self._dbstmnt.result[8]
        self.orec.ext_data = self._dbstmnt.result[9]
        self.orec.modified_by = self._dbstmnt.result[10]
        self.orec.tm_stamp = self._dbstmnt.result[11]

        return True

    async def fetch_all(self, outList: tBatch.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

