# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_item_for_inserting import iBatchItemForInserting
from bs_monitor.db.tables.obatch_item_for_inserting import oBatchItemForInserting

class dBatchItemForInserting:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchItemForInserting()
        self.orec     = oBatchItemForInserting()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        batch_id: int) -> "dBatchItemForInserting":
        """
        Execute the query by setting all the inputs.

        :param batch_id: int
        :return: Self for convenience.
        """
        self.irec.batch_id = batch_id

        return await self.exec()

    async def exec(self, irec: iBatchItemForInserting = None) -> "dBatchItemForInserting":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchItemForInserting", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  i.job_id,
  i.extra_args,
  j.group_id,
  substring(j.name, 1, 32),
  j.priority
from
  monitor.batchitem i
    join
  monitor.job j
    on j.id = i.job_id
where
  i.batch_id = :batchId
order by
  i.id""")

        self._dbstmnt.bind_in("batchId", self.irec.batch_id, int, 8)

        self._dbstmnt.bind_out("jobId", int, 8)
        self._dbstmnt.bind_out("extraArgs", str, 128)
        self._dbstmnt.bind_out("groupJob", str, 128)
        self._dbstmnt.bind_out("groupBatch", str, 256)
        self._dbstmnt.bind_out("priority", int, 4)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.job_id = self._dbstmnt.result[0]
        self.orec.extra_args = self._dbstmnt.result[1]
        self.orec.group_job = self._dbstmnt.result[2]
        self.orec.group_batch = self._dbstmnt.result[3]
        self.orec.priority = self._dbstmnt.result[4]

        return True

    async def fetch_all(self, outList: oBatchItemForInserting.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

