# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Wed May 12 14:47:13 2021
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.mondate_key import tMondateKey
from bs_monitor.db.tables.mondate import tMondate

class dMondateLockOne:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tMondateKey()
        self.orec     = tMondate()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        id: str) -> "dMondateLockOne":
        """
        Execute the query by setting all the inputs.

        :param id: str
        :return: Self for convenience.
        """
        self.irec.id = id

        return await self.exec()

    async def exec(self, irec: tMondateKey = None) -> "dMondateLockOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("MondateLockOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  id,
  descr,
  value,
  stamp_by,
  stamp_tm
from
  monitor.Mondate
where
  id = :id for update nowait""")

        self._dbstmnt.bind_in("id", self.irec.id, str, 16)

        self._dbstmnt.bind_out("id", str, 16)
        self._dbstmnt.bind_out("descr", str)
        self._dbstmnt.bind_out("value", datetime.date)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        await self._dbcon.lock(self._dbstmnt)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.descr = self._dbstmnt.result[1]
        self.orec.value = self._dbstmnt.result[2]
        self.orec.stamp_by = self._dbstmnt.result[3]
        self.orec.stamp_tm = self._dbstmnt.result[4]

        return True

    async def fetch_all(self, outList: tMondate.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

